=== debian/changelog ===
clamav (1.0.9+dfsg-1~deb12u1) bookworm; urgency=medium

  * Import 1.0.9
    - CVE-2025-20128 (Fixed a possible buffer overflow read bug in the OLE2
      file parser that could cause a denial-of-service (DoS) condition)
      Closes: #1093880
    - CVE-2025-20260 (Fixed a possible buffer overflow write bug in the PDF
      file parser that could cause a denial-of-service (DoS) condition or
      enable remote code execution.) Closes: #1108046

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 29 Jun 2025 21:57:41 +0200
